﻿using ServerOperations.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using System.Web.Http.OData;
using System.Web.Http.OData.Query;

namespace ServerOperations.Controllers
{
    public class OrdersController : ApiController
    {
        // GET api/orders
        NorthwindDataContext db = new NorthwindDataContext();
        public PageResult<Order> Get(ODataQueryOptions opts)
        {
            List<Order> ord = db.Orders.ToList();

            return new PageResult<Order>(opts.ApplyTo(ord.AsQueryable()) as IEnumerable<Order>, null, ord.Count);
        }

        // GET api/orders/5
        [HttpGet]
        public string Get(int id)
        {
            return "value";
        }

        // POST api/orders
        [HttpPost]
        public void Post(Order value)
        {
            NorthwindDataContext db = new NorthwindDataContext();

            db.Orders.InsertOnSubmit(new Order()
            {
                OrderID = value.OrderID,
                CustomerID = value.CustomerID,
                EmployeeID = value.EmployeeID,
                OrderDate = value.OrderDate,
                ShipCity = value.ShipCity,
                ShipCountry = value.ShipCountry,
                Freight = value.Freight,
                ShipName = value.ShipName
            });

            db.SubmitChanges();
           
        }

        // PUT api/orders/5
        [HttpPut]
        public void Put(Order value)
        {
            Order ord = (Order)db.Orders.Single(s => s.OrderID == value.OrderID);

            ord.OrderID = value.OrderID;
            ord.CustomerID = value.CustomerID;
            ord.EmployeeID = value.EmployeeID;
            ord.OrderDate = value.OrderDate;
            ord.ShipCity = value.ShipCity;
            ord.ShipCountry = value.ShipCountry;
            ord.Freight = value.Freight;
            ord.ShipName = value.ShipName;


            db.SubmitChanges();
        }

        // DELETE api/orders/5
        [HttpDelete]
        public void Delete(int id)
        {
            Order ord = (Order)db.Orders.Single(s => s.OrderID == id);

            db.Orders.DeleteOnSubmit(ord);

            db.SubmitChanges();
        }
    }
}
